# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
%bcond_without mead

%if "%{?rhel}" == "6"
%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif
%else
%bcond_with repolib
%endif

%define reltag .redhat_3
%define namedreltag -redhat-3
%global namedversion %{version}%{?namedreltag}

%define section free

%define maven_version 1.6.2-redhat-3

Name:           joda-time
Version:        1.6.2
Release:        5%{?reltag}%{?dist}.4
Epoch:          0
Summary:        Date and time library to replace JDK date handling
Group:          Development/Java

%if %with mead
Source100: joda-time-joda-time-1.6.2-redhat-3-sources.zip
Source101: joda-time-joda-time-1.6.2-redhat-3-patches.zip
Source102: joda-time-1.6.2-redhat-3-sources.jar
Source103: joda-time-1.6.2-redhat-3.jar
Source104: joda-time-1.6.2-redhat-3-javadoc.jar
Source105: joda-time-1.6.2-redhat-3.pom
%endif

License:        ASL 2.0
URL:            http://joda-time.sourceforge.net/
%if %without mead
# git clone git://git.app.eng.bos.redhat.com/joda-time.git
# cd joda-time && git checkout v1.6.2 && cd ..
# HEAD is now at 845f00c... Prepare for v1.6.2
# tar czf joda-time-1.6.2.tar.gz joda-time
##Source0:        http://prdownloads.sourceforge.net/joda-time/joda-time-1.6.2-src.tar.gz
Source0:        joda-time-%{version}.tar.gz
Patch0:         joda-time-pom.patch
Patch1:         joda-time-pom-versions.patch
%endif
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java >= 0:1.5.0
Requires:       jpackage-utils

%if %without mead
BuildRequires:  commons-parent
BuildRequires:  jboss-parent
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils
BuildRequires:  junit4
BuildRequires:  maven2
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-clean
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-repository
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Joda-Time provides a quality replacement for the Java date 
and time classes. The design allows for multiple calendar 
systems, while still providing a simple API. The 'default' 
calendar is the ISO8601 standard which is used by XML. The 
Gregorian, Julian, Buddhist, Coptic and Ethiopic systems 
are also included, and we welcome further additions. 
Supporting classes include time zone, duration, format 
and parsing. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %without mead
%package manual
Summary:        Docs for %{name}
Group:          Development/Documentation


%description manual
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n joda-time-%{version}-src
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%{__perl} -pi -e 's/\r$//g;' LICENSE.txt
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
# FIXME: (dwalluck): why is this commons-lang bootclasspath needed?
export MAVEN_OPTS="-Xms1g -Xmx1g -Xbootclasspath/p:`%{_bindir}/build-classpath commons-lang`"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate
%endif

%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p target/joda-time-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p target/joda-time-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%endif
%{__ln_s} %{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}.jar
%{__ln_s} %{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-sources.jar

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%endif
%add_to_maven_depmap joda-time joda-time %{namedversion} JPP %{name}

%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/META-INF
%endif
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if 0
%{__mkdir_p} %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/* %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_docdir}/%{name}
%{__rm} -r %{buildroot}%{_docdir}/%{name}-%{namedversion}/apidocs
%{__ln_s} %{_javadocdir}/%{name} %{buildroot}%{_docdir}/%{name}-%{namedversion}/apidocs
%endif

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%if %without mead
%doc LICENSE.txt
%endif
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{namedversion}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if 0
%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{namedversion}
%doc %{_docdir}/%{name}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6.2-5.redhat_3.4
- Rebuild for MD5

* Mon Sep 10 2012 Paul Gier <pgier@redhat.com> - 0:1.6.2-4.redhat_3.4
- Update pom to use bom versions for dependencies

* Mon Aug 20 2012 Paul Gier <pgier@redhat.com> - 0:1.6.2-4.redhat_2.3
- Update pom patch for eap 6.0.1

* Thu Aug 09 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6.2-4.redhat_2.2
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6.2-4.redhat_1.1
- Rebuild using cache signing

* Wed Jun 20 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.6.2-4.redhat_1
- Build in MEAD

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.6.2-3.3_redhat_1.1
- Rebuild using cache signing

* Fri Feb 03 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.6.2-3.3
- Rebuild

* Thu Jan 19 2012 David Walluck <dwalluck@redhat.com> 0:1.6.2-3.2
- add redhat to pom patch

* Mon Aug 22 2011 David Walluck <dwalluck@redhat.com> 0:1.6.2-3.1
- update pom patch
- add repolib

* Tue Aug 16 2011 David Walluck <dwalluck@redhat.com> 0:1.6.2-3
- fix file list for brew
- update BuildRequires

* Mon Jun 06 2011 David Walluck <dwalluck@redhat.com> 0:1.6.2-2
- remove manual (which is not building)

* Fri May 27 2011 David Walluck <dwalluck@redhat.com> 0:1.6.2-1
- 1.6.2
- site does not build

* Thu Oct 07 2010 David Walluck <dwalluck@redhat.com> 0:1.5.2-2
- add pom

* Tue May 27 2008 Ralph Apel <r.apel at r-apel.de> - 0:1.5.2-1jpp
- 1.5.2

* Mon Dec 17 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.2.1-2jpp
- Add BRs

* Mon May 22 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.2.1-1jpp
- First JPP-1.7 release
